poj3253 Fence Repair STL优先队列

转载请注明出处:http://blog.csdn.net/u012860063

题目链接:http://poj.org/problem?id=3253

Description

Farmer John wants to repair a small length of the fence around the pasture. He measures the fence and finds that he needs N (1 ≤ N ≤ 20,000) planks of wood, each having some integer length Li (1 ≤ Li ≤
50,000) units. He then purchases a single long board just long enough to saw into the N planks (i.e., whose length is the sum of the lengths Li). FJ is ignoring the "kerf", the extra length lost to sawdust when a sawcut is made;
you should ignore it, too.

FJ sadly realizes that he doesn‘t own a saw with which to cut the wood, so he mosies over to Farmer Don‘s Farm with this long board and politely asks if he may borrow a saw.

Farmer Don, a closet capitalist, doesn‘t lend FJ a saw but instead offers to charge Farmer John for each of the N-1 cuts in the plank. The charge to cut a piece of wood is exactly equal to its length. Cutting a plank of length 21 costs 21 cents.

Farmer Don then lets Farmer John decide the order and locations to cut the plank. Help Farmer John determine the minimum amount of money he can spend to create the N planks. FJ knows that he can cut the board in various different orders which will
result in different charges since the resulting intermediate planks are of different lengths.

Input

Line 1: One integer N, the number of planks

Lines 2..N+1: Each line contains a single integer describing the length of a needed plank

Output

Line 1: One integer: the minimum amount of money he must spend to make N-1 cuts

Sample Input

3
8
5
8

Sample Output

34

Hint

He wants to cut a board of length 21 into pieces of lengths 8, 5, and 8.

The original board measures 8+5+8=21. The first cut will cost 21, and should be used to cut the board into pieces measuring 13 and 8. The second cut will cost 13, and should be used to cut the 13 into 8 and 5. This would cost 21+13=34. If the 21 was cut into
16 and 5 instead, the second cut would cost 16 for a total of 37 (which is more than 34).

Source

USACO 2006 November Gold

大致题意:

有一个农夫要把一个木板钜成几块给定长度的小木板,每次锯都要收取一定费用,这个费用就是当前锯的这个木版的长度

给定各个要求的小木板的长度,及小木板的个数n,求最小费用

提示:

3

5 8 5为例:

先从无限长的木板上锯下长度为 21 的木板,花费 21

再从长度为21的木板上锯下长度为5的木板,花费5

再从长度为16的木板上锯下长度为8的木板,花费8

总花费 = 21+5+8 =34

解题思路:

利用Huffman思想,要使总费用最小,那么每次只选取最小长度的两块木板相加,再把这些“和”累加到总费用中即可

本题虽然利用了Huffman思想,但是直接用HuffmanTree做会超时,可以用优先队列做

代码如下:

/*STL 优先队列*/
#include <cstdio>
#include <queue>
#include <vector>
#include <iostream>
using namespace std;
int main()
{
	int n;//需要切割的木板个数
	__int64 temp,a,b,mincost;
	while(~scanf("%d",&n))
	{
		//定义从小到大的优先队列,可将greater改为less,即为从大到小
		priority_queue<int, vector<int>, greater<int> > Q;

		while(!Q.empty())//清空队列
			Q.pop();

		for(int i = 1; i <= n; i++)
		{
			scanf("%I64d",&temp);
			Q.push(temp);//输入要求的木板长度(费用)并入队
		}

		mincost = 0;//最小费用初始为零

		while(Q.size() > 1)//当队列中小于等于一个元素时跳出
		{
			a = Q.top();//得到队首元素的值,并使其出队
			Q.pop();
			b = Q.top();//两次取队首,即得到最小的两个值
			Q.pop();
			Q.push(a+b);//把两个最小元素的和入队
			mincost +=a+b;
		}
		printf("%I64d\n",mincost);
	}
	return 0;
}

poj3253 Fence Repair STL优先队列,布布扣,bubuko.com

时间: 2024-10-26 20:10:18

poj3253 Fence Repair STL优先队列的相关文章

Fence Repair STL——优先队列

题目描述: Farmer John wants to repair a small length of the fence around the pasture. He measures the fence and finds that he needs N (1 ≤ N ≤ 20,000) planks of wood, each having some integer length Li (1 ≤ Li ≤ 50,000) units. He then purchases a single

poj3253 Fence Repair【优先队列】

大意: 需要把一根长木棍锯成一些短木棍 短木棍的长度是告诉你的 每一次锯的花费为要锯的改段的长度 问最小花费 比如n个小木棍长度分别5 8 8 也就是相当于你有一根21的木棍  现在需要把它锯成 上述的三段 每次只能把一个木棍锯成两段 比如21可以锯成13 和 8   但是由于选择的是21  所以花费为21 第二次把13 锯成5和8  花费 为13 总花费为21 + 13 = 34 分析: 其实我们可以逆向思维 想在有n跟木棍现在想要把他们拼成一跟 每一次的花费就是这两段的和 那么我们根据贪心的

POJ3253 Fence Repair 小顶堆+贪心

给了你N个木棒,求把他们组装成一根需要的最小花费,每次只能选两根组装在一起,需要的花费为两个木棒之和, 以前遇到过把一整根切开的,那个是DP,这个则有些类似,可是大胆的猜测了一下,直接每次选取所有木棒中最短的两根,这样就可以了,那么贪心是适用的,但是数量很多,而且两根最短的组装好了得插回去,这样不可能每次都排序吧, 这题首先优先队列肯定是可以做的, 最小堆也是可以的,每次都选出堆里的最小的两个求和再放回去即可 队列本身也就是堆吧,所以差别不大,但是没用过最小堆最大堆的 所以用一次把 #inclu

POJ 3253 Fence Repair (优先队列)

POJ 3253 Fence Repair (优先队列) Farmer John wants to repair a small length of the fence around the pasture. He measures the fence and finds that he needsN (1 ≤ N ≤ 20,000) planks of wood, each having some integer lengthLi (1 ≤ Li ≤ 50,000) units. He the

poj 3253 Fence Repair(优先队列+哈夫曼树)

题目地址:POJ 3253 哈夫曼树的结构就是一个二叉树,每一个父节点都是两个子节点的和.这个题就是可以从子节点向根节点推. 每次选择两个最小的进行合并.将合并后的值继续加进优先队列中.直至还剩下一个元素为止. 代码如下: #include <iostream> #include <stdio.h> #include <string.h> #include <stdlib.h> #include <math.h> #include <cty

POJ 3253 Fence Repair(优先队列,哈夫曼树)

题目 //做哈夫曼树时,可以用优先队列(误?) //这道题教我们优先队列的一个用法:取前n个数(最大的或者最小的) //哈夫曼树 //64位 //超时->优先队列,,,, //这道题的优先队列用于取前2个小的元素 #include <iostream> #include<stdio.h> #include<string.h> #include<algorithm> #include<queue> using namespace std; _

优先队列 poj3253 Fence Repair

Fence Repair Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 51411   Accepted: 16879 Description Farmer John wants to repair a small length of the fence around the pasture. He measures the fence and finds that he needs N (1 ≤ N ≤ 20,000)

poj-3253 Fence Repair[霍夫曼树]

Fence Repair Time Limit: 2000MS Description Farmer John wants to repair a small length of the fence around the pasture. He measures the fence and finds that he needs N (1 ≤ N ≤ 20,000) planks of wood, each having some integer length Li (1 ≤ Li ≤ 50,0

poj3253 Fence Repair【哈夫曼树+优先队列】

Description Farmer John wants to repair a small length of the fence around the pasture. He measures the fence and finds that he needs N (1 ≤ N ≤ 20,000) planks of wood, each having some integer length Li (1 ≤ Li ≤ 50,000) units. He then purchases a s